BOOT1S ;boot1s/asm
 	ORG	4200H
 BUFFER	EQU	4300H
 	LD	DE,0700H
 	LD	L,-1
 	EXX
 LOOP	CALL	GET1B
 	CP	1
 	JR	Z,LOAD
 	CP	2
 	JR	Z,START
 	CP	20H
 	JP	NC,ERROR
 	CALL	GET1B
 	LD	B,A
 LOOP2	CALL	GET1B
 	DJNZ	LOOP2
 	JR	LOOP
 START	CALL	GET1B
 	CALL	GETLOAD
 	JP	(HL)
 GETLOAD	CALL	GET1B
 	LD	L,A
 	CALL	GET1B
 	LD	H,A
 	RET
 LOAD	CALL	GET1B
 	LD	B,A
 	CALL	GETLOAD
 	DEC	B
 	DEC	B
 LOAD2	CALL	GET1B
 	LD	(HL),A
 	CP	(HL)
 	JP	NZ,ERROR
 	INC	HL
 	DJNZ	LOAD2
 	JR	LOOP		;go again
 SELECT	LD	A,1
 	LD	(37E1H),A
 	RET
 GET1B	EXX
 	INC	L
 	JR	NZ,HAVE1B
 	LD	BC,BUFFER
 	CALL	READ
 	JP	NZ,ERROR
 	INC	E
 	LD	A,E
 	SUB	10
 	JR	NZ,HAVE1B
 	LD	E,A
 	INC	D
 HAVE1B	LD	A,(HL)
 	EXX
 	RET
 READ	PUSH	BC
 	CALL	READ1
 	POP	HL
 	RET	Z
 	LD	B,H
 	LD	C,L
 READ1	LD	HL,37ECH
 	CALL	SELECT
 	CALL	SEEK
 	LD	A,88H
 	LD	(HL),A
 	CALL	DSKSLO
 	PUSH	DE
 	LD	DE,37EFH
 	JR	RD2
 RD1	RRCA
 	JR	NC,RD3
 RD2	LD	A,(HL)
 	BIT	1,A
 	JR	Z,RD1
 	LD	A,(DE)
 	LD	(BC),A
 	INC	BC
 	JR	RD2
 RD3	LD	A,(HL)
 	POP	DE
 	LD	(HL),0D0H
 	AND	9FH
 	RET
 DSKSLO	PUSH	BC
 	LD	B,12
 	DJNZ	$
 	POP	BC
 	RET
 SEEK	LD	(37EEH),DE
 	CALL	SELECT
 	LD	A,(42FFH)
 	AND	3
 	OR	18H
 	LD	(HL),A
 	CALL	DSKSLO
 SEEKWT	LD	A,(HL)
 	BIT	0,A
 	JR	NZ,SEEKWT
 	RET
 ERROR	LD	HL,MSG
 	CALL	PRINT
 	CALL	40H
 	HALT
 PRINT	LD	A,(HL)
 	INC	HL
 	OR	A
 	RET	Z
 	CALL	33H
 	JR	PRINT
 MSG	DB	1CH,1FH,'* Error * '
 	DB	0,0,0,0,0,0,0,0,0,0,0
 	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 	DB	'SU+ Boot Speed='
 	DB	'3'
 	END	4200H
